#!/usr/bin/perl
open(IN, "<emu.dat");
open(OUT, ">emu.out");
$ss=0;

$state=0;

while($ss<3*256){

$j=0;
$first = 1;
$last = 0;
sleep(1);
while( $last < 2 && ($j<256 || $state > 100) ){
	$rx = ord(getc(IN));
	$ss++;
	#printf("got(%d)\n",$rx);

	#switch($state){
			if ($state == 0){ #case (0): 
				#//no packet header rcv, wait for header:
				if ($rx == 0xF9){
					$state = 1;
				}else{
					printf("seek@0x%x(%02x)\n",$ss,$rx);
				}	
				#//else: do nothing
				break;
			}elsif($state==1){ #case (1):
				##//we got a F9
				if ($rx == 0x83){
					$state = 2; #//we have a data packet
				}elsif ($rx == 0xF9){
					$state = 1; #//this is the real start byte
					printf("out of sync\n");
					#//printf("read(0x%02x)\n",rx);
					#//printf("out of sync .. packet=%d, j=%d\n", webcam_buffer_empty,j);
					#//printf("buf before: %02x %02x %02x %02x\n",
					#//	 webcam_buffer[j-3],webcam_buffer[j-2],
					#//	 webcam_buffer[j-1],webcam_buffer[j-0]);
				}else{
					#//printf("read(0x%02x)\n",rx);
					#//printf("@packet:%d: bytepos:%d: ERR[0x%02x]\n",webcam_buffer_empty,j,rx);
					$state =0;
				}
				break;
			}elsif($state==2){ #case 2:
				#//now we expect EF
				if ($rx == 0xEF){
					$state = 3;
				}else{
					#//printf("read(0x%02x)\n",rx);
					#//printf("ERR: no 0xEF!->0x%02x\n", rx);
					$state = 0;
				}
				break;
			}elsif($state==3){ #case 3: 	
				#//next byte is frame len:
				$togo = ($rx-1)/2; #//rx/2
				
				if ($togo<31){
					$last = 1;
				}
				#printf("len=%d\n",$togo);
				if ($togo != 31 && $togo != 13){ printf("len=%d\n",$togo); }
				$state = 4;
				break;
			}elsif($state==4){ #case 4:
				#//if we got 0x90 this is a ackAck packet
				if ($rx == 0x90){
					$skip  = 5; #//skip next 5byte (=total 6 skipped)
					$state = 5; #//goto skip
				}else{
					#//this is 1 data byte -> write:
					@webcam_buffer[$j] = $rx;
					printf("OUT[%03d] 0x%02x\n",$j,$rx);
					$j++;
					
					$togo  = $togo - 1; #//we have read already 1 byte from frame
					$state = 6;  #//goto handle data
				}
				break;
			}elsif($state==5){ #case 5:
				#//skip acks
				$skip--;
				if ($skip == 0){
					$togo = $togo - 6; #//we have read already 6 bytes from frame
					$state = 6; #//goto handle data
				}
				break;
			}elsif($state==6){ #case 6:
				#//now sample data:
				$webcam_buffer[$j] = $rx;
				printf("OUT[%03d] 0x%02x\n",$j,$rx);
				$j++;
				$togo--;
				if ($togo == 0){
					$state = 7;
				}
				break;
			}elsif($state==7){ #case 7:
				#//data is there now we read checksum:
				#//ignore CS...
				#//printf("CSUM=%02x\n",rx);
				$state = 8;
				break;
			}elsif($state==8){ #case 8: 
				#//we have frame end:
				if ($rx != 0xF9){
					printf("FRAME ERROR! @packet:%d: (0x%02x)\n",$webcam_buffer_empty,$rx);
				}
				#//printf("EOF=%d\n\n",rx);
				$state = 0;
				#sleep(1);
				printf("---\n");
				if ($last == 1){ $last = 2; }
				break;
			}else{ #default:
				printf("oh no .... this should never ever happen :-X\n");
		}
}
printf("got data: ");
for ($i=0; $i<$j; $i++){
	#printf(OUT "%c", @webcam_buffer[$i]);
	printf(" %02x", @webcam_buffer[$i]);
}
printf("\n[[[ las=%d\n",$j);
printf("\n\n");
}